=== debian/changelog ===
ros-melodic-find-object-2d (0.6.2-1stretch) stretch; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Mathieu Labbe <matlabbe@gmail.com>  Tue, 22 May 2018 15:38:56 -0000
