## ros-melodic-find-object-2d 0.7.0

=== debian/changelog ===
ros-melodic-find-object-2d (0.7.0-2bionic) bionic; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Mathieu Labbe <matlabbe@gmail.com>  Sun, 11 Dec 2022 23:33:05 -0000
